<template>
	<v-form ref="formAddressData" v-model="isValid">
		<v-card>
			<v-card-text>
				<!-- fila de datos locales -->
				<v-row>
					<v-col cols="12" sm="3">
						<v-select
							v-model="addressData.state"
							prepend-icon="fas fa-flag"
							outlined
							:rules="ruleRequired"
							:items="states"
							label="Estado"
							required
						/>
					</v-col>
					<v-col cols="12" sm="3">
						<v-select
							v-model="addressData.city"
							no-data-text="Seleccione antes un estado"
							prepend-icon="fas fa-flag"
							outlined
							:rules="ruleRequired"
							:items="cities"
							label="Municipio"
							required
						/>
					</v-col>
					<v-col cols="12" sm="6">
						<v-text-field
							v-model="addressData.neighborhood"
							prepend-icon="fas fa-flag"
							outlined
							:rules="ruleRequired"
							label="Colonia"
							required
						/>
					</v-col>
				</v-row>
				<!-- fila de direccion -->
				<v-row>
					<v-col cols="12" sm="5">
						<v-text-field
							v-model="addressData.street"
							prepend-icon="fas fa-road"
							outlined
							:rules="ruleRequired"
							label="Calle"
							required
						/>
					</v-col>
					<v-col cols="12" sm="4">
						<v-text-field
							v-model="addressData.number"
							prepend-icon="fas fa-home"
							outlined
							:rules="ruleRequired"
							label="Número de casa"
							required
						/>
					</v-col>
					<v-col cols="12" sm="3">
						<v-text-field
							type="number"
							min="0"
							prepend-icon="fas fa-envelope-open"
							outlined
							:rules="rulesCP"
							v-model="addressData.postalCode"
							label="Código postal"
							required
						/>
					</v-col>
				</v-row>
				<!-- fila de numeros telefónicos -->
				<v-row>
					<v-col cols="12" sm="4">
						<v-text-field
							type="number"
							v-model="addressData.mobilePhoneNumber"
							prepend-icon="fas fa-mobile-alt"
							outlined
							:rules="rulesPhones"
							min="0"
							label="Teléfono celular"
							required
						/>
					</v-col>
					<v-col cols="12" sm="4">
						<p slot="label" class="headline">¿Tienes teléfono fijo?</p>
						<v-radio-group
							row
							v-model="haveNumberPhone"
							mandatory
							prepend-icon="fas fa-phone-slash"
							required
						>
							<v-radio label="No" value="No" color="blue" />
							<v-radio label="Si" value="Si" color="blue" />
						</v-radio-group>
					</v-col>
					<v-col cols="12" sm="4" v-if="numberPhone">
						<v-text-field
							type="number"
							v-model="addressData.housePhoneNumber"
							prepend-icon="fas fa-phone"
							outlined
							:rules="rulesPhones"
							min="0"
							label="Teléfono de casa"
							required
						/>
					</v-col>
				</v-row>
			</v-card-text>
			<v-card-actions>
				<v-row justify-sm="start">
					<v-col cols="12" sm="3">
						<v-btn block outlined color="red" @click="back">Regresar</v-btn>
					</v-col>
					<v-col cols="12" sm="3">
						<v-btn
							:disabled="!isValid || !saved"
							:loading="loading"
							block
							outlined
							color="green"
							@click="save"
						>
							Guardar
							<template v-slot:loader>
								<span>Guardando...</span>
							</template>
						</v-btn>
					</v-col>
					<v-col cols="12" sm="3">
						<v-btn :disabled="saved" block outlined color="blue" @click="next">Siguiente</v-btn>
					</v-col>
				</v-row>
			</v-card-actions>
		</v-card>
	</v-form>
</template>

<script>
import EventBus from "../../bus";
import { mapActions } from "vuex";
import gql from "graphql-tag";

export default {
	name: "FormAddressData",
	data: () => ({
		isValid: true,
		saved: true,
		loading: false,
		haveNumberPhone: "No",
		addressData: {
			state: "",
			city: "",
			neighborhood: "",
			street: "",
			number: "",
			postalCode: "",
			housePhoneNumber: "",
			mobilePhoneNumber: ""
		},
		states: [],
		cities: [],
		ruleRequired: [value => !!value || "Campo requerido"],
		rulesCP: [
			value => !!value || "Campo requerido",
			value => (value || "").length === 5 || "5 números obligatorios"
		],
		rulesPhones: [
			value => !!value || "Campo requerido",
			value => (value || "").length === 10 || "10 números obligatorios"
		]
	}),
	computed: {
		// condiciona si tiene numero fijo o no
		numberPhone() {
			return this.haveNumberPhone === "No" ? false : true;
		}
	},
	watch: {
		// Escucha el input del estado para consultar los municipios
		"addressData.state": function(newValue, oldValue) {
			this.getCities();
		}
	},
	methods: {
		...mapActions(["saveAddressData"]),
		// Obtiene los estados de México
		async getStates() {
			try {
				const states = await this.$apollo.query({
					query: gql`
						query {
							allStates
						}
					`
				});
				this.states = states.data.allStates;
			} catch (error) {}
		},
		// Obtiene los municipios del estado seleccionado
		async getCities() {
			try {
				const cities = await this.$apollo.query({
					query: gql`
						query($state: String!) {
							allCities(state: $state)
						}
					`,
					variables: {
						state: this.addressData.state
					}
				});
				this.cities = cities.data.allCities;

			} catch (error) {}
		},
		// LLama a la accion que guarda los datos
		save() {
			this.saveAddressData(this.addressData);
			this.loading = true;
		},
		//
		next() {
			EventBus.$emit("nextStep");
		},
		back() {
			EventBus.$emit("backStep");
		}
	},
	created() {
		this.getStates();
	},
	mounted() {
		// Habilita el boton de siguiente
		EventBus.$on("addressDataSaved", () => {
			setTimeout(() => {
				this.loading = false;
				this.saved = false;
			}, 1500);
		});
	}
};
</script>